/*
 * Test access(existing file) and then open(for reading/writing) race condition
 * race condition attack vector: rm /tmp/race && ln -s /etc/passwd /tmp/race (after acccess completes)
 */

#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <err.h>


#define	PATH	"/tmp/race"


int main()
{
	int	fd, n;
	char	buf[256];


	if (access(PATH, 0) != 0)
		err(1, "access");


	printf("sleeping for 3 seconds after access()\n");
	sleep(3);


	if ((fd = open(PATH, O_RDONLY, 0)) < 0)
		err(2, "open");

	n = read(fd, buf, 255);
	buf[n] = '\0';

	printf("Read '%s' from %s\n", buf, PATH);

	close(fd);


	return 0;
}
