/*
 * Test chdir(directory) and then open(file for writing) race condition
 * (http://archives.neohapsis.com/archives/bugtraq/2002-03/0096.html)
 * race condition attack vector: XXX mv /tmp/a/b/c /tmp/a (after chdir completes)
 */

#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <err.h>


#define	PATH	"/tmp/a/b/c/"
#define	FILE	PATH ## "file"


int main()
{
	int	fd, n;
	char	buf[256];


	if (chdir(PATH) != 0)
		err(1, "chdir");


	printf("sleeping for 3 seconds after chdir()\n");
	sleep(3);


	if ((fd = open(FILE, O_RDONLY, 0)) < 0)
		err(2, "open");

	n = read(fd, buf, 255);
	buf[n] = '\0';

	printf("Read '%s' from %s\n", buf, PATH);

	close(fd);


	return 0;
}
