/*
 * Test stat(non-existent file) and then open(for writing) race condition
 * race condition attack vector: ln -s /etc/passwd /tmp/race (after stat completes)
 * WARNING: The above example will clobber your /etc/passwd file!
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <err.h>


int
main()
{
	struct stat	sb;
	int		fd;


	if (stat("/tmp/race", &sb) != 0)
		warn("stat /tmp/race");
	else
		errx(1, "/tmp/race already exists");


	printf("sleeping for 3 seconds after stat()\n");
	sleep(3);


	if ((fd = open("/tmp/race", O_CREAT | O_RDWR, 0)) < 0)
		err(1, "open");


#define	STR	"/tmp/race\n"

	if (write(fd, STR, strlen(STR)) != strlen(STR))
		warnx("write failed");


	close(fd);


	return 0;
}
